import BaseEvent from './BaseEvent';
import { DataForIsomorphicEvent } from './EventTypings';
export interface EventOptions {
    bubbles?: boolean;
    cancelable?: boolean;
    setTimeStamp?: boolean;
}
export declare type EventOptionsMap<TTypes extends string> = {
    [T in TTypes]: EventOptions;
};
declare class IsomorphicBaseEvent<TTypes extends Array<string>, TDataTypes extends Array<any>, TType extends TTypes[number]> extends BaseEvent<DataForIsomorphicEvent<TType, TTypes, TDataTypes>, TType> {
    type: TType;
    data: DataForIsomorphicEvent<TType, TTypes, TDataTypes>;
    typeOptions: EventOptionsMap<TTypes[number]>;
    constructor(type: TType, data: DataForIsomorphicEvent<TType, TTypes, TDataTypes>, typeOptions: EventOptionsMap<TTypes[number]>);
    clone(): IsomorphicBaseEvent<TTypes, TDataTypes, TType>;
}
export default IsomorphicBaseEvent;
