import { DataForIsomorphicEvent } from './EventTypings';
import IsomorphicBaseEvent, { EventOptions, EventOptionsMap } from './IsomorphicBaseEvent';
declare type TypeMap<TType extends string> = {
    [P in TType]: P;
};
declare function createIsomorphicEventType<TDataTuple extends Array<any>>(...eventOptions: Array<EventOptions>): <TTypesTuple extends string[] & {
    length: TDataTuple["length"];
}>(...types: TTypesTuple) => {
    new <TType extends TTypesTuple[number] = TTypesTuple[number]>(type: TType, data: DataForIsomorphicEvent<TType, TTypesTuple, TDataTuple>): {
        type: TType;
        data: DataForIsomorphicEvent<TType, TTypesTuple, TDataTuple>;
        typeOptions: EventOptionsMap<TTypesTuple[number]>;
        clone(): IsomorphicBaseEvent<TTypesTuple, TDataTuple, TType>;
        bubbles: boolean;
        cancelable: boolean;
        currentTarget: import("./EventDispatcher").default<import("./AbstractEvent").default> | null;
        target: import("./EventDispatcher").default<import("./AbstractEvent").default> | null;
        eventPhase: import("./EventPhase").default;
        timeStamp: number;
        defaultPrevented: boolean;
        stopPropagation(): void;
        stopImmediatePropagation(): void;
        preventDefault(): void;
        callListener(handler: import("./EventTypings").EventHandlerForEvent<any>): import("./CallListenerResult").default;
    };
    types: TypeMap<TTypesTuple[number]>;
};
export default createIsomorphicEventType;
